Monguava - Mongoose + Guava
============

Monguava makes realtime mongodb queries possible. Tradionally, you would pull data from the database, but monguava also supports it in reverse. Monguava allows you to *listen to any query* to the mongo, and bind to that query for any new inserted data. 

Goals:
------

- Better alternative to mongodb's tailing cursor function.
- Allow for database-driven applications to be more realtime.
- Reduce number of hits to the database.
- better flexability for applications providing realtime functionality. 

Example:
--------

```javascript


var monguava = require('monguava');

var con = monguava.createConnection('mongodb://minimacblack.local/hello');

var messages = con.collection('messages');



messages.find({name: 'craig'}, function(err, cursor)
{
	cursor.toArray(function(err, stack)
	{
		// console.log(stack);
	})


	//BOUND
	cursor.bind(function(person)
	{
		console.log(person.name+" "+person._id);//craig XXXXXXXsomeid
	});


	messages.insert({ name: 'craig' }, function(){})
	messages.insert({ name: 'john' }, function(){})
});


```



## License

Copyright (c) 2010 LearnBoost &lt;dev@learnboost.com&gt;

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
'Software'), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
