
var Collection = require('mongodb').Collection,
Cursor = require('mongodb').Cursor,
Guava = require('guava').Client;
var NativeCollection = require('./collection');

Collection.prototype.__defineGetter__("bindableCollectionName", function()
{
	return this.db.databaseName+':'+this.collectionName;
});


NativeCollection.prototype.__defineGetter__("bindableCollectionName", function()
{
	return this.collection.bindableCollectionName;
});



Collection.prototype.__defineGetter__("binding", function()
{
	return Guava.collection(this.bindableCollectionName);
});

NativeCollection.prototype.__defineGetter__("binding", function()
{
	return this.collection.binding;
});

Collection.prototype.emit = NativeCollection.prototype.emit = function(data, ops)
{
	this.binding.emit(data, ops);
}

Collection.prototype.emitAdd = NativeCollection.prototype.emitAdd = function(data)
{
	this.emit(data, 'add');
}

Collection.prototype.emitRemove = NativeCollection.prototype.emitRemove = function(data)
{
	this.emit(data, 'remove');
}

Collection.prototype.bind = NativeCollection.prototype.bind = function(query, callback)
{
	this.binding.on(query, callback);
}

Collection.prototype.bindable = NativeCollection.prototype.bindable = function(query)
{
	return { collection: this.bindableCollectionName, query: query };
}


var oldInsert = Collection.prototype.insert;

Collection.prototype.insert = function(doc, options, callback)
{
	if ('function' === typeof options) callback = options, options = {};
  	if(options == null) options = {};
	if(!('function' === typeof callback)) callback = null;

	var self = this;

	var onInsert = function(err, items)
	{
		if(callback) callback.apply(null, arguments);

		
		self.emitAdd(items);
	}

	oldInsert.call(this, doc, options, options.emit ? onInsert : callback);
}

var oldRemove = Collection.prototype.remove;

Collection.prototype.remove = function(selector, options, callback)
{
	if ('function' === typeof selector)
	{
    	callback = selector;
    	selector = options = {};
  	} 
  	else 
  	if ('function' === typeof options) 
  	{
    	callback = options;
    	options = {};
  	}

  	var self = this;


  	var onRemove = function()
  	{
  		callback.apply(null, arguments);

  		self.emitRemove(options.emit)
  	}

  	oldRemove.call(this, selector, options, typeof options.emit == 'object' ? onRemove : callback);
}


Cursor.prototype.bind = function(callback)
{
	return this.collection.bind(this.selector, callback);
}

/*var oldToArray = Cursor.prototype.toArray;

Cursor.prototype.toArray = function(callback)
{
	var self = this,
	onResult = function()
	{
		callback.call(self, err, result, self)
	}

	oldToArray.apply(this, onResult);
}*/

Cursor.prototype.__defineGetter__("bindable", function()
{
	return this.collection.bindable(this.selector);
});